/***************************************************************
This code was written by Franz Franchetti
See www.ece.cmu.edu/~franzf and www.spiral.net for details
Copyright (c) 2005, Carnegie Mellon University
All rights reserved.

This code is distributed for evaluation only and may not be 
used for any other purposes. Redistribution without prior consent
by the authors is prohibited.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

* Redistributions of source code must retain the above copyright
  notice, reference to Spiral, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials provided
  with the distribution.
* Neither the name of Carnegie Mellon University nor the name of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*AS IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************/

#ifndef __THREADS_H__
#define __THREADS_H__

#define MAX_PROC	128

#if defined(_WIN32) || defined(_WIN64)
#define USE_WIN_THREADS
#else
#define USE_PTHREADS
#endif

#ifdef USE_PTHREADS
#include <nptl/pthread.h>
#define __cdecl
#define CREATE_THREAD(worker, data)						\
{														\
	pthread_t threads[MAX_PROC];						\
	pthread_create(&threads[i], NULL, worker, &data);	\
}

#define CREATE_THREAD_NODATA(worker)					\
{														\
	pthread_t threads[MAX_PROC];						\
	pthread_create(&threads[i], NULL, worker, NULL);	\
}

#endif

#ifdef USE_WIN_THREADS
#include <process.h>
#include <windows.h>
#define CREATE_THREAD(worker, data)	_beginthread(worker, 0, &data)
#define CREATE_THREAD_NODATA(worker)	_beginthread(worker, 0, NULL)
#endif

#endif